<template>
    <div>
        <el-form :inline="true" :model="query" class="query-form" size="mini">
            <el-row>
                <el-form-item class="query-form-item">
                    <el-input v-model="filterQuery.genKey" placeholder="记录ID"></el-input>
                </el-form-item>
                <el-form-item>
                    <el-button-group style="display:flex;">
                        <el-button type="primary" icon="el-icon-refresh" @click="onReset"></el-button>
                        <el-button type="primary" icon="search" @click="getList">查询</el-button>
                        <el-button type="primary" icon="search" @click="exportExcel">导出Excel文件</el-button>
                    </el-button-group>
                </el-form-item>
            </el-row>
        </el-form>

        <el-table
            v-loading="loading"
            :data="list"
            style="width: 100%"
            @selection-change="handleSelectionChange"
        >
            <el-table-column label="序号" type="index"></el-table-column>
            <el-table-column
                label="记录ID"
                prop="genKey"
                show-overflow-tooltip
            ></el-table-column>


            <el-table-column
                label="更新日期"
                prop="updateTime"
                show-overflow-tooltip
            ></el-table-column>
            <el-table-column
                label="状态"
                prop="status"
                show-overflow-tooltip
            >
                <template slot-scope="scope">
                    <el-tag
                        :type="statusFilterType(scope.row.status)"
                    >{{ status[scope.row.status] }}
                    </el-tag
                    >
                </template>
            </el-table-column>
            <el-table-column
                label="下载次数"
                prop="dlCount"
                show-overflow-tooltip
            >
            </el-table-column>
            <el-table-column label="操作" fixed="right" width="160">
                <template slot-scope="scope">
                    <el-button
                        type="text"
                        size="small"
                        @click.native.stop="downloadExcel(scope.row)"
                    >下载
                    </el-button
                    >
                    <el-button
                        type="text"
                        size="small"
                        @click.native.stop="deleteDialog(scope.row.id)"
                    >删除
                    </el-button
                    >
                </template>
            </el-table-column>
        </el-table>

        <el-dialog
            title="导出产品信息"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            :visible.sync="thrProductsSelectVisible"
            width="85%"
            v-if="thrProductsSelectVisible"
        >
            <thrProductsSelect :selectType="selectType" v-on:cancelDialog="cancelDialog"
            ></thrProductsSelect>
        </el-dialog>

        <el-pagination
            :page-size="filterQuery.limit"
            @current-change="handleCurrentChange"
            layout="prev, pager, next"
            :total="total"
            :current-page="filterQuery.page"
        ></el-pagination>
    </div>
</template>

<script>
    import {filterLog, deleteLog} from "../../api/thrsys/thrProductsExport.js";
    import thrProductsSelect from "./ThrProductsSelect";
    import axios from "axios";
    export default {
        data() {
            return {
                filterQuery: {
                    genKey: null,
                    status: null,
                    fromType: null,
                    page: 1,
                    limit: 20,
                    thirdSysFk: null,
                },
                selectType: 0,
                thrProductsSelectVisible: false,
                list: [],
                detailList: [],
                thirdSys: [],
                thirdSysDetail: null,
                total: 0,
                editQuery: null,
                fromStatus: {
                    0: "产品信息",
                    1: "库存信息",
                    2: "异常第三方上传"
                },
                status: {
                    0: "等待处理",
                    1: "正在处理",
                    2: "处理异常",
                    3: "处理完成"
                },
                uploadFileUrl: null,
                uploadData: {
                    thirdSys: "thirdId",
                },
            };
        },

        methods: {
            onReset() {
                this.$router.push({
                    path: "",
                });
                this.filterQuery = {
                    fromType: null,
                    genKey: null,
                    status: null,
                    page: 1,
                    limit: 20,
                    thirdSysFk: null,
                };
                this.getList();
            },
            getList() {
                this.loading = true;
                filterLog(this.filterQuery)
                    .then((response) => {
                        if (response.code == 20000) {
                            this.list = response.data.list || [];
                            this.total = response.data.total || 0;
                        }else {
                            this.$message.error(response.message);
                        }
                        this.loading = false;
                    })
                    .catch(() => {
                        this.loading = false;
                        this.list = [];
                        this.total = 0;
                    });
            },

            exportExcel() {
                this.selectType = 0;
                this.thrProductsSelectVisible = true;
            },
            uploadSmp() {
                this.selectType = 1;
                this.thrProductsSelectVisible = true;
            },
            downloadExcel(row) {
                axios.get("./config.json").then(res => {
                    let baseUrl = res.data.BASE_URL;
                    let href = baseUrl + "/udiwms/thrProducts/exportLog/download" + "?genKey=" + row.genKey;
                    let a = document.createElement("a");
                    fetch(href)
                        .then((res) => res.blob())
                        .then((blob) => {
                            a.href = URL.createObjectURL(blob);
                            console.log(a.href);
                            a.download =
                                row.filePath.split("\\")[
                                row.filePath.split("\\").length - 1
                                    ];
                            document.body.appendChild(a);
                            a.click();
                            this.getList();
                        });
                });

            },

            cancelDialog(val) {
                if (val) {
                    this.getList();
                }
                this.thrProductsSelectVisible = false;
            },
            handleCurrentChange(val) {
                this.filterQuery.page = val;
                this.getList();
            },
            deleteDialog(rowId) {
                this.$confirm("此操作将删除该导出记录, 是否继续?", "提示", {
                    confirmButtonText: "确定",
                    cancelButtonText: "取消",
                    type: "warning",
                })
                    .then(() => {
                        let dQuery = {
                            id: rowId,
                        };
                        deleteLog(dQuery)
                            .then((response) => {
                                this.loading = false;
                                if (response.code == 20000) {
                                    this.$message.success("删除成功");
                                } else {
                                    this.$message.error(response.message);
                                }
                                this.getList();
                            })
                            .catch(() => {
                                this.loading = false;
                            });
                    })
                    .catch(() => {
                    });
            },
            handleChange(response, files, fileList) {
                console.log(response);
                if (response.code != 20000) {
                    this.$message.error(response.message);
                } else {
                    console.log(files[0] + "\n" + this.fileList[0] + "\n" + fileList[0]);
                    this.$message.success("文件上传成功,请稍后刷新查看！");
                }
            },
            statusFilterType(status) {
                const statusMap = {
                    0: "warning",
                    1: "warning",
                    2: "danger",
                    3: "success",
                };
                return statusMap[status];
            },
        },
        mounted() {
        },
        components: {thrProductsSelect},
        created() {
            // this.getBasicThirdSys();
            this.getList();
        },
    };
</script>
<style>
    .itemTag {
        float: left;
        text-align: left;
        margin-top: 10px;
        width: 100px;
    }

    .text {
        font-size: 13px;
        font-family: "Microsoft YaHei";
    }

    .el-row {
        display: flex;
        flex-wrap: wrap;

    }

    .el-col {
        border-radius: 4px;
        flex-wrap: wrap;
    }
</style>
